<?php
/**
 * Números crecientes - numeros_crecientes_3.php
 *
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2012 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2012-06-04
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
  <title>Números crecientes (Resultado).
  Exámenes. PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css"
  title="Color" />
</head>

<body>
<h1>Números crecientes (Resultado)</h1>
<?php
function recoge($var)
{
    $tmp = (isset($_REQUEST[$var])) ? strip_tags(trim(htmlspecialchars($_REQUEST[$var]))) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    return $tmp;
}

function recogeMatriz($var)
{
    $tmpMatriz = array();
    if (isset($_REQUEST[$var]) && is_array($_REQUEST[$var])) {
        foreach ($_REQUEST[$var] as $indice => $valor) {
            $tmp = strip_tags(trim(htmlspecialchars($indice)));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $indiceLimpio = $tmp;

            $tmp = strip_tags(trim(htmlspecialchars($valor)));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $valorLimpio  = $tmp;

            $tmpMatriz[$indiceLimpio] = $valorLimpio;
        }
    }
    return $tmpMatriz;
}

$numero       = recoge('numero');
$datos        = recogeMatriz('datos');
$numeroOk     = FALSE;
$datosOk      = TRUE;
$crecientesOk = TRUE;

if ($numero=="") {
    print "<p class=\"aviso\">No ha escrito el número.</p>\n";
} elseif (!is_numeric($numero)) {
    print "<p class=\"aviso\">No ha escrito el número como número.</p>\n";
} elseif (!ctype_digit($numero)) {
    print "<p class=\"aviso\">No ha escrito el número como número entero.</p>\n";
} elseif ($numero<2) {
    print "<p class=\"aviso\">El número debe ser mayor que 1.</p>\n";
} else {
    $numeroOk = TRUE;
}
if ($numeroOk) {
    for ($i = 1; $i <= $numero; $i++) {
        if ($datos[$i]=="") {
            print "<p class=\"aviso\">No ha escrito el dato $i.</p>\n";
            $datosOk = FALSE;
        } elseif (!is_numeric($datos[$i])) {
            print "<p class=\"aviso\">No ha escrito el dato $i como número.</p>\n";
            $datosOk = FALSE;
        } elseif (!ctype_digit($datos[$i])) {
            print "<p class=\"aviso\">No ha escrito el dato $i como número entero.</p>\n";
            $datosOk = FALSE;
        }
    }
}

if ($numeroOk && $datosOk) {
    for ($i = 1; $i < $numero; $i++) {
        if ($datos[$i] >= $datos[$i+1]) {
            print "<p class=\"aviso\">El dato $i no es inferior al dato ".($i+1).".</p>\n";
            $crecientesOk = FALSE;
        }
    }
    if ($crecientesOk) {
        print "<p>Los números introducidos van en orden creciente.<p>\n";
    } else {
        print "<p class=\"aviso\">Los números introducidos no van en orden creciente.</p>\n";
    }
}
print "<p><a href=\"numeros_crecientes_1.php\">Volver a empezar.</a></p>\n";

?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 4 de junio de 2012
</address>
<p class="licencia">El programa PHP que genera esta página está bajo
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
